// JavaScript Document
function Cgame(gameDivId){
	var game=this;
	this.status=0;
	this.UI=false;
	this.config=false;
	this.categ=false;this.categId=0;
	this.time=0;
	this.gameDiv=document.getElementById(gameDivId);
	this.clientWidth=this.clientHeight=0;
	this.homeURL=homeURL+'js/games/pitb/';
	//sounds
	this.music=false;
	this.shuffle=false;
	this.correct=false;
	this.fail=false;
	this.turningbox=false;
	this.gameover=false;
	
	this.Load=Load;function Load(){
		this.DrawInterval=setInterval(RunMain,30);
		this.UI=new CUI(this);
		ajaxGetStr(this.homeURL+'config/config.json',this.LoadConfig,this);
	}
	
	this.LoadConfig=LoadConfig;function LoadConfig(str){
		this.config=JSON.parse(str);
		var v;
		v=this.config.game_Parameters.sound_Effects.GeneralMusic;
		if(v.audio_mp3 && v.audio_ogg){this.music=new Caudio(this);this.music.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
		v=this.config.game_Parameters.sound_Effects.EntryAnimation;
		if(v.audio_mp3 && v.audio_ogg){this.shuffle=new Caudio(this);this.shuffle.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
		v=this.config.game_Parameters.sound_Effects.correctAnswer;
		if(v.audio_mp3 && v.audio_ogg){this.correct=new Caudio(this);this.correct.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
		v=this.config.game_Parameters.sound_Effects.incorrectAnswer;
		if(v.audio_mp3 && v.audio_ogg){this.fail=new Caudio(this);this.fail.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
		v=this.config.game_Parameters.sound_Effects.turningBoxAnimation;
		if(v.audio_mp3 && v.audio_ogg){this.turningbox=new Caudio(this);this.turningbox.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
		v=this.config.game_Parameters.sound_Effects.GameOver;
		if(v.audio_mp3 && v.audio_ogg){this.gameover=new Caudio(this);this.gameover.LoadSound(this.homeURL+'assets/'+v.audio_mp3,this.homeURL+'assets/'+v.audio_ogg);}
	}
	
	this.LoadElements=LoadElements;function LoadElements(str){
		var i,j;
		var loadV=JSON.parse(str);
		if(loadV.length>1)
			this.categ=loadV[this.categId];
		else
			this.categ=loadV[0];
		
		var Elements=new Array();
		
		//reducing the total number of subcategories(buckets) to 4
		while(this.categ.Sub_Category.length>4){
			j=Math.floor(Math.random()*this.categ.Sub_Category.length);
			this.categ.Sub_Category.splice(j,1);
		}
		for(i=0;i<this.categ.Sub_Category.length;i++){
			this.categ.Sub_Category[i].sound=new Caudio(this);
			if(this.categ.Sub_Category[i].audio_mp3 && this.categ.Sub_Category[i].audio_ogg){//subcateg sound
				this.categ.Sub_Category[i].sound.LoadSound(this.homeURL+'assets/'+this.categ.Sub_Category[i].audio_mp3,this.homeURL+'assets/'+this.categ.Sub_Category[i].audio_ogg);
			}
			if(this.categ.Sub_Category[i].image){//subcateg icon
				this.categ.Sub_Category[i].Images=new Array();
				preloadImage(this.categ.Sub_Category[i].Images,0,this.homeURL+'assets/'+this.categ.Sub_Category[i].image);
			}
			while(this.categ.Sub_Category[i].Elements.length>this.config.game_attributes.Num_of_elements){
				j=Math.floor(Math.random()*this.categ.Sub_Category[i].Elements.length);
				this.categ.Sub_Category[i].Elements.splice(j,1);
			}
			for(j=0;j<this.categ.Sub_Category[i].Elements.length;j++){
				Elements[Elements.length]={
					categ:i,
					id:j					
				};
																 
				this.categ.Sub_Category[i].Elements[j].sound=false;
				if(this.categ.Sub_Category[i].Elements[j].audio_mp3 && this.categ.Sub_Category[i].Elements[j].audio_ogg){//subcateg sound
					this.categ.Sub_Category[i].Elements[j].sound=new Caudio(this);
					this.categ.Sub_Category[i].Elements[j].sound.LoadSound(this.homeURL+'assets/'+this.categ.Sub_Category[i].Elements[j].audio_mp3,this.homeURL+'assets/'+this.categ.Sub_Category[i].Elements[j].audio_ogg);
				}
				if(this.categ.Sub_Category[i].Elements[j].image){//subcateg icon
					this.categ.Sub_Category[i].Elements[j].Images=new Array();
					preloadImage(this.categ.Sub_Category[i].Elements[j].Images,0,this.homeURL+'assets/'+this.categ.Sub_Category[i].Elements[j].image);
				}
			}
		}
		var steps=30;
		for(i=0;i<Elements.length;i++){
			Elements[i].x=-200*this.UI.scaleVal;
			Elements[i].y=-200*this.UI.scaleVal;
			Elements[i].rot=180-Math.random()*360;
			Elements[i].Dx=(550*this.UI.scaleVal)*Math.random();
			Elements[i].Dy=(220*this.UI.scaleVal)*Math.random();
			Elements[i].Drot=45-Math.random()*90;
			Elements[i].dx=(Elements[i].Dx-Elements[i].x)/steps;
			Elements[i].dy=(Elements[i].Dy-Elements[i].y)/steps;
			Elements[i].drot=(Elements[i].Drot-Elements[i].rot)/steps;
		}
		this.categ.Elements=shuffle(Elements);
	}
	
	this.categLoaded=categLoaded;function categLoaded(){
		var i,j;
		if(!this.categ)return(false);
		for(i=0;i<this.categ.Sub_Category.length;i++){
			if(this.categ.Sub_Category[i].sound && !this.categ.Sub_Category[i].sound.ready())return(false);
			if(!imagesLoaded(this.categ.Sub_Category[i].Images))return(false);
			for(j=0;j<this.categ.Sub_Category[i].Elements.length;j++){
				if(this.categ.Sub_Category[i].Elements[j].sound && !this.categ.Sub_Category[i].Elements[j].sound.ready())return(false);
				if(!imagesLoaded(this.categ.Sub_Category[i].Elements[j].Images))return(false);
			}
		}
		return(true);
	}
	
	this.LoadOk=LoadOk;function LoadOk(){
		if(!this.config)return(false);
		if(!this.UI || !this.UI.LoadOk())return(false);
		if(this.music && !this.music.ready())return(false);
		if(this.shuffle && !this.shuffle.ready())return(false);
		if(this.correct && !this.correct.ready())return(false);
		if(this.fail && !this.fail.ready())return(false);
		if(this.turningbox && !this.turningbox.ready())return(false);
		if(this.gameover && !this.gameover.ready())return(false);
		return(true);
	}
	
	this.Resize=Resize;function Resize(Pwidth,Pheight){
		this.clientWidth=Pwidth;
		this.clientHeight=Pheight;
		var obj=document.getElementById('UIContainer');
		if(obj){
			obj.style.width=Pwidth+'px';
			obj.style.height=Pheight+'px';
		}
		this.UI.scaleVal=Pwidth/720;
		if(this.status=='playing'){
			this.UI.mainDiv.innerHTML='';
//			this.UI.status='playing';
			for(i=0;i<this.categ.Elements.length;i++){
				this.categ.Elements[i].x=this.categ.Elements[i].Dx=(550*this.UI.scaleVal)*Math.random();
				this.categ.Elements[i].y=this.categ.Elements[i].Dy=(220*this.UI.scaleVal)*Math.random();
				this.categ.Elements[i].rot=this.categ.Elements[i].Drot=45-Math.random()*90;
				this.categ.Elements[i].dx=this.categ.Elements[i].dy=this.categ.Elements[i].drot=0.0;
			}
			this.UI.startingGame();
			obj=document.getElementById('UIContainer');
			if(obj)obj.style.backgroundPosition='0px -'+(100*this.UI.scaleVal)+'px';
			obj=document.getElementById('boxesContainer');
			if(obj)obj.style.marginTop=((355)*this.UI.scaleVal)+'px';
		}
		this.UI.status=false;
	}
	
	this.newGame=newGame;function newGame(Pcateg){
		this.status='loading category';
		if(Pcateg<0)Pcateg=Math.floor(Math.random()*this.config.categories.length);
		this.categ=false;this.categId=Pcateg;
		this.UI.Zindex=200;
		ajaxGetStr(this.config.categories[Pcateg].elementsUrl,this.LoadElements,this);
	}
	
	this.Run=Run;function Run(){
		var date=new Date();
		this.time=date.getTime();
		if(this.gameDiv){
			cw=this.gameDiv.clientWidth;ch=this.gameDiv.clientHeight;
			if(cw/ch>720/503)cw=ch*720/503;else ch=cw*503/720;
			if(this.clientWidth!=cw || this.clientHeight!=ch){
				this.Resize(cw,ch);
			}
		}
		switch(this.status){
			case(0)://initial loading
				if(this.LoadOk())this.status='main menu';
//				if(this.LoadOk())this.status='game over';
				break;
			case('loading category'):
				if(this.categLoaded())this.status='starting game';
				break;
			case('playing'):
				break;
			default:break;
		}
		if(this.UI)this.UI.Run(this.status);
	}
	function RunMain(){game.Run();}
	this.Load();
}
function debugStr(str){
	var obj=document.getElementById('watchContainer');
	if(obj)obj.innerHTML=str;
}
function shuffle(array) {
  var currentIndex = array.length, temporaryValue, randomIndex;

  // While there remain elements to shuffle...
  while (0 !== currentIndex) {

    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;

    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}